<script lang="ts">
  import SkillRoll from './SkillRoll.svelte'
  import type { BaseCharacter } from '../../module/model/character.js'
  import type { ModifierDescriptor } from '../../module/model/modifier.js'
  import { FormulaParameterClassNames } from '../../module/model/myranor-magic.js'
  import type { Formula } from '../../module/model/properties.js'
  import { FormulaModificatorValues } from '../../module/model/myranor-magic.js'
  import { FormulaModifications } from '../../module/ruleset/rules/myranor/formula.js'

  export var localize: (_key: string) => string
  export var skill: Formula
  export var character: BaseCharacter

  export var callback: (
    modifiers: Map<string, ModifierDescriptor>,
    options?: Record<string, unknown>
  ) => void

  let modifiers = character.sourceModifiers(skill)

  let rollSourceParameters = {}

  FormulaParameterClassNames.forEach((parameterName) => {
    rollSourceParameters[parameterName] = {}
    FormulaModificatorValues.forEach((modifierValue) => {
      rollSourceParameters[parameterName][modifierValue] = Object.entries(
        FormulaModifications[parameterName]
      )
        .filter((entry) => entry[1] === modifierValue)
        .map((entry) => localize(`formula-${parameterName}-${entry[0]}`))
        .join('\n')
    })
  })

  const updateMod = (event) => {
    const radioButton = event.target
    const category = radioButton.name
    const value = parseInt(radioButton.value)
    modifiers.get(category).mod = value
    modifiers = modifiers
  }
</script>

<SkillRoll bind:modifiers {callback} {localize} {skill}>
  <div slot="skill-options">
    <table class="source-roll">
      <tr>
        <th>{localize('modificator')}</th>
        {#each FormulaParameterClassNames as category}
          <th>{localize(`formula-${category}`)}</th>
        {/each}
      </tr>

      {#each FormulaModificatorValues as modificator}
        <tr>
          <td>
            <div style="text-align: center">
              {modificator < 0 ? modificator : `+ ${modificator}`}
            </div>
          </td>
          {#each FormulaParameterClassNames as category}
            <td>
              <div style="display:flex;flex-wrap: wrap">
                <div style="margin-right:5px">
                  <input
                    type="radio"
                    id="{category}{modificator}"
                    data-testid="source-mod-{category}-{modificator}"
                    on:change={updateMod}
                    name={category}
                    value={modificator}
                    style="vertical-align: middle;height: 100%"
                  />
                </div>
                <div>
                  <label
                    for="{category}{modificator}"
                    style="white-space:pre-wrap"
                    >{rollSourceParameters[category][modificator]}</label
                  >
                </div>
              </div>
            </td>
          {/each}
        </tr>
      {/each}
    </table>
  </div>
</SkillRoll>
